if($Pref::Server::AdminTimeout::Timeout_Ban $= "")
	$Pref::Server::AdminTimeout::Timeout_Ban = 5;
if($Pref::Server::AdminTimeout::Timeout_Kick $= "")
	$Pref::Server::AdminTimeout::Timeout_Kick = 3;
if($Pref::Server::AdminTimeout::Timeout_Default $= "")
	$Pref::Server::AdminTimeout::Timeout_Default = 5;
if($Pref::Server::AdminTimeout::ApplyToSAs_Ban $= "")
	$Pref::Server::AdminTimeout::ApplyToSAs_Ban = 0;
if($Pref::Server::AdminTimeout::ApplyToSAs_Kick $= "")
	$Pref::Server::AdminTimeout::ApplyToSAs_Kick = 0;
if($Pref::Server::AdminTimeout::ApplyToSAs_Default $= "")
	$Pref::Server::AdminTimeout::ApplyToSAs_Default = 0;

package AdminTimeouts
{
	function servercmdBan(%cl, %targCl, %targBLID, %time, %reason)
	{
		//The ban is being done by the console or the host - no timeout.
		if(!isObject(%cl) || %cl.bl_id == getNumKeyID())
			Parent::servercmdBan(%cl, %targCl, %targBLID, %time, %reason);
		else
		{
			//You can't ban yet!
			if(!%cl.AdminTO_CanDoAction("Ban"))
			{
				%cl.chatMessage("\c6You can't ban again yet. Please wait "@mCeil(%cl.AdminTO_GetTimeLeft("Ban"))@" more seconds.");
				return;
			}
			else
			{
				Parent::servercmdBan(%cl, %targCl, %targBLID, %time, %reason);
				%cl.AdminTO_ApplyTimeout("Ban");
			}
		}
	}
	
	function servercmdKick(%cl, %targCl, %reason)
	{
		//The ban is being done by the host - no timeout.
		if(cl.bl_id == getNumKeyID())
			Parent::servercmdKick(%cl, %targCl, %reason);
		else
		{
			//You can't kick yet!
			if(!%cl.AdminTO_CanDoAction("Kick"))
			{
				%cl.chatMessage("\c6You can't ban again yet. Please wait "@mCeil(%cl.AdminTO_GetTimeLeft("Kick"))@" more seconds.");
				return;
			}
			else
			{
				Parent::servercmdKick(%cl, %targCl, %reason);
				%cl.AdminTO_ApplyTimeout("Kick");
			}
		}
	}
};
activatePackage("AdminTimeouts");

function GameConnection::AdminTO_ApplyTimeout(%cl, %action)
{
	//Check whether this action's timeout applies to superadmins.
	if(%cl.isSuperAdmin)
	{
		%applyToSAs = $Pref::Server::AdminTimeout::ApplyToSAs_[%action];
		if(%applyToSAs $= "") %applyToSAs = $Pref::Server::AdminTimeout::ApplyToSAs_Default;
		if(!%applyToSAs) return;
	}
	
	//Set the timeout to this instant.
	%cl.lastAdminAction = getSimTime();
}

function GameConnection::AdminTO_CanDoAction(%cl, %action)
{
	//What level of admin are we?
	if(%cl.isSuperAdmin) %level = 2;
	else if(%cl.isAdmin) %level = 1;
	else return 0;
	
	//Find the timeout for this action.
	%timeout = $Pref::Server::AdminTimeout::Timeout_[%action];
	if(%timeout $= "") %applyToSAs = $Pref::Server::AdminTimeout::Timeout_Default;
	
	//Does this action's timeout apply to superadmins?
	%applyToSAs = $Pref::Server::AdminTimeout::ApplyToSAs_[%action];
	if(%applyToSAs $= "") %applyToSAs = $Pref::Server::AdminTimeout::ApplyToSAs_Default;
	
	//If it doesn't, superadmins can always do it.
	if(%level == 2 && !$Pref::Server::AdminTimeout::ApplyToSAs_[%action])
		return 1;
	
	%time = vectorDist(%cl.lastAdminAction, getSimTime()) / 1000;
	return %time >= %timeout;
}

function GameConnection::AdminTO_GetTimeLeft(%cl, %action)
{
	//What level of admin are we?
	if(%cl.isSuperAdmin) %level = 2;
	else if(%cl.isAdmin) %level = 1;
	else return 999999;
	
	//Find the timeout for this action.
	%timeout = $Pref::Server::AdminTimeout::Timeout_[%action];
	if(%timeout $= "") %applyToSAs = $Pref::Server::AdminTimeout::Timeout_Default;
	
	//Does this action's timeout apply to superadmins?
	%applyToSAs = $Pref::Server::AdminTimeout::ApplyToSAs_[%action];
	if(%applyToSAs $= "") %applyToSAs = $Pref::Server::AdminTimeout::ApplyToSAs_Default;
	
	//If it doesn't, superadmins can always do it.
	if(%level == 2 && !$Pref::Server::AdminTimeout::ApplyToSAs_[%action])
		return 0;
	
	%time = vectorDist(%cl.lastAdminAction, getSimTime()) / 1000;
	return %timeout - %time;
}